
var API_URL = "http://www.pamperbook.co.uk";
//var API_URL = "http://192.168.0.102";
//var API_URL = "http://www.testsite.dev";

// Ionic Starter App

angular.module('underscore', [])
        .factory('_', function () {
            return window._; // assumes underscore has already been loaded on the page
        });
// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
var app = angular.module('your_app_name', [
    'ionic',
    'angularMoment',
    'your_app_name.controllers',
    'your_app_name.directives',
    'your_app_name.filters',
    'your_app_name.services',
    'your_app_name.factories',
    'your_app_name.config',
    //'your_app_name.views',
    'underscore',
    'ngMap',
    'ngResource',
    'ngCordova',
    'slugifier',
    'ionic.contrib.ui.tinderCards',
    'youtube-embed',
    'onezone-datepicker',
    'ionic.rating',
    'ngMessages',
    'ion-gallery',
    'ionic-timepicker'
])

        .run(function ($ionicPlatform, PushNotificationsService, $rootScope, $ionicConfig, $timeout, ConnectivityMonitor, $ionicPopup, $localstorage, $state) {

            //Popup Message
            $rootScope.noInternetPopup = function (initialFail) {
                initialFail = initialFail || false;
                $ionicPopup.show({
                    title: "No Internet Connection",
                    subTitle: "<br/>Sorry, There is no Internet connection. Please Connect and retry.",
                    buttons: [
                        {
                            text: '<b>Retry</b>',
                            type: 'button-positive',
                            onTap: function (e) {
                                if (initialFail) {
                                    ionic.Platform.exitApp();
                                }
                                else if (ConnectivityMonitor.isOffline()) {
                                    //don't allow the user to close unless Internet Connected
                                    e.preventDefault();
                                }
                            }
                        }
                    ]

                });
            };

            $rootScope.API_URL = API_URL;

            $ionicPlatform.on("deviceready", function () {
                // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
                // for form inputs)
                if (window.cordova && window.cordova.plugins.Keyboard) {
                    cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                }
                if (window.StatusBar) {
                    StatusBar.styleDefault();
                }

                //Check for Internet Connection and Monitor First
                //ConnectivityMonitor.startWatching();
                if (ConnectivityMonitor.isOffline()) {
                    $rootScope.noInternetPopup(true);
                } else {
                    ConnectivityMonitor.startWatching();
                }

                //PushNotificationsService.register();
                var notificationOpenedCallback = function (jsonData) {
                    console.log('notificationOpenedCallback: ' + JSON.stringify(jsonData));
                };
                window.plugins.OneSignal
                        .startInit("b60e6ff5-d735-41ba-bee1-e44f9b062fd9", "824834132574")
                        .handleNotificationOpened(notificationOpenedCallback)
                        .endInit();


            });
            // This fixes transitions for transparent background views
            $rootScope.$on("$stateChangeStart", function (event, toState, toParams, fromState, fromParams) {
                if (toState.name.indexOf('auth.walkthrough') > -1)
                {
                    // set transitions to android to avoid weird visual effect in the walkthrough transitions
                    $timeout(function () {
                        $ionicConfig.views.transition('android');
                        $ionicConfig.views.swipeBackEnabled(false);
                        console.log("setting transition to android and disabling swipe back");
                    }, 0);
                }
            });
            $rootScope.$on("$stateChangeSuccess", function (event, toState, toParams, fromState, fromParams) {
                if (toState.name.indexOf('app.feeds-categories') > -1)
                {
                    // Restore platform default transition. We are just hardcoding android transitions to auth views.
                    $ionicConfig.views.transition('platform');
                    // If it's ios, then enable swipe back again
                    if (ionic.Platform.isIOS())
                    {
                        $ionicConfig.views.swipeBackEnabled(true);
                    }
                    console.log("enabling swipe back and restoring transition to platform default", $ionicConfig.views.transition());
                }
            });
            $ionicPlatform.on("resume", function () {
                //PushNotificationsService.register();
            });
        })


        .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
            $stateProvider
                    //INTRO
                    .state('auth', {
                        url: "/auth",
                        templateUrl: "views/auth/auth.html",
                        abstract: true,
                        controller: 'AuthCtrl'
                    })

                    //device id Register
                    //api/save-deviceId

                    .state('app', {
                        url: "/app",
                        abstract: true,
                        templateUrl: "views/app/side-menu.html",
                        controller: 'AppCtrl'
                    })

                    //Selection : Salon or Fashion
                    .state('app.selection', {
                        url: "/selection",
                        views: {
                            'menuContent': {
                                templateUrl: "views/common/select-option.html",
                                controller: 'AuthCtrl'
                            }
                        }
                    })

                    //Location, Treatment incase of Salon
                    .state('app.location', {
                        url: "/location",
                        views: {
                            'menuContent': {
                                templateUrl: "views/common/location.html",
                                controller: 'LocationCtrl'
                            }
                        }
                    })

                    .state('app.treatment', {
                        url: "/treatment",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/salon/select-treatment.html",
                                controller: 'TreatmentCtrl'
                            }
                        }
                    })


                    //Salon Search

                    .state('app.salon-search', {
                        url: "/salon-search",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/salon-search.html",
                                controller: 'SalonSearchCtrl'
                            }
                        }
                    })

                    .state('app.scheduler', {
                        url: "/scheduler",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/scheduler.html",
                                controller: 'SchedulerCtrl'
                            }
                        }
                    })

                    //My Booking

                    .state('app.booking', {
                        url: "/booking",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/booking.html",
                                controller: 'BookingCtrl'
                            }
                        }
                    })

                    .state('app.pending', {
                        url: "/pending",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/pending.html",
                                controller: 'PendingCtrl'
                            }
                        }
                    })

                    .state('app.upcoming', {
                        url: "/upcoming",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/upcoming.html",
                                controller: 'UpcomingCtrl'
                            }
                        }
                    })

                    //Customer Detail
                    .state('app.customer', {
                        url: "/viewCustomer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewcustomer.html",
                                controller: 'CustomerCtrl'
                            }
                        }
                    })

                    .state('app.addCustomer', {
                        url: "/addCustomer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addCustomer.html",
                                controller: 'AddCustomerCtrl'
                            }
                        }
                    })


                    //Staff Detail
                    .state('app.staff', {
                        url: "/viewStaff",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewstaff.html",
                                controller: 'StaffCtrl'
                            }
                        }
                    })

                    .state('app.addStaff', {
                        url: "/addStaff",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addStaff.html",
                                controller: 'AddStaffCtrl'
                            }
                        }
                    })

                    .state('app.editStaff', {
                        url: "/editStaff",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/editStaff.html",
                                controller: 'EditStaffCtrl'
                            }
                        }
                    })

                    .state('app.staffService', {
                        url: "/staffService",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/staffService.html",
                                controller: 'StaffServiceCtrl'
                            }
                        }
                    })

                    //Budget Booking
                    .state('app.budgetBooking', {
                        url: "/viewBudgetBooking",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewBudgetBooking.html",
                                controller: 'BudgetBookingCtrl'
                            }
                        }
                    })

                    .state('app.addBookingBid', {
                        url: "/addBookingBid",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addBookingBid.html",
                                controller: 'AddBookingBidCtrl'
                            }
                        }
                    })

                    .state('app.viewSelectedBooking', {
                        url: "/viewSelectedBooking",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewSelectedBooking.html",
                                controller: 'ViewSelectedBookingCtrl'
                            }
                        }
                    })

                    .state('app.viewService', {
                        url: "/viewService",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewService.html",
                                controller: 'ViewServiceCtrl'
                            }
                        }
                    })

                    .state('app.serviceDetail', {
                        url: "/serviceDetail",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/serviceDetail.html",
                                controller: 'ServiceDetailCtrl'
                            }
                        }
                    })

                    .state('app.addService', {
                        url: "/addService",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addService.html",
                                controller: 'AddServiceCtrl'
                            }
                        }
                    })

                    .state('app.addNewService', {
                        url: "/addNewService",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addNewService.html",
                                controller: 'AddNewServiceCtrl'
                            }
                        }
                    })

                    .state('app.addSpecialOffer', {
                        url: "/addSpecialOffer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addSpecialOffer.html",
                                controller: 'AddSpecialOfferCtrl'
                            }
                        }
                    })

                    .state('app.editSpecialOffer', {
                        url: "/editSpecialOffer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/editSpecialOffer.html",
                                controller: 'EditSpecialOfferCtrl'
                            }
                        }
                    })

                    //Special Offer
                    .state('app.specialOffer', {
                        url: "/viewSpecialOffer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewSpecialOffer.html",
                                controller: 'SpecialOfferCtrl'
                            }
                        }
                    })

                    .state('app.addProfile', {
                        url: "/addProfile",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addProfile.html",
                                controller: 'AddProfileCtrl'
                            }
                        }
                    })

                    .state('app.addLocation', {
                        url: "/addLocation",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addLocation.html",
                                controller: 'AddLocationCtrl'
                            }
                        }
                    })

                    .state('app.addCustomerDiscount', {
                        url: "/addCustomerDiscount",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addCustomerDiscount.html",
                                controller: 'AddCustomerDiscountCtrl'
                            }
                        }
                    })

                    .state('app.saveSocialLink', {
                        url: "/saveSocialLink",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/saveSocialLink.html",
                                controller: 'SaveSocialLinkCtrl'
                            }
                        }
                    })

                    .state('app.galleryImage', {
                        url: "/galleryImage",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/galleryImage.html"
                            }
                        }
                    })

                    .state('app.addOpeningTime', {
                        url: "/addOpeningTime",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addOpeningTime.html",
                                controller: 'AddOpeningTimeCtrl'
                            }
                        }
                    })

                    .state('app.editCustomer', {
                        url: "/editCustomer",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/editCustomer.html",
                                controller: 'EditCustomerCtrl'
                            }
                        }
                    })

                    .state('app.viewUnavailable', {
                        url: "/viewUnavailable",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/viewUnavailable.html",
                                controller: 'UnavailableCtrl'
                            }
                        }
                    })

                    .state('app.addAppointment', {
                        url: "/addAppointment",
                        cache: false,
                        params: {
                            objDate: null,
                            objStaff: null,
                        },
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addAppointment.html",
                                controller: 'AddAppointmentCtrl'
                            }
                        }
                    })

                    .state('app.addUnavailability', {
                        url: "/addUnavailability",
                        cache: false,
                        params: {
                            objDate: null,
                            objStaff: null,
                        },
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/addUnavailability.html",
                                controller: 'AddUnavailabilityCtrl'
                            }
                        }
                    })

                    //Appointment Detail
                    .state('app.appointment', {
                        url: "/appointment",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/appointment.html",
                                controller: 'AppointmentCtrl'
                            }
                        }
                    })

                    //save salon review - salon/user/order/rating/desc
                    .state('app.booking-rating', {
                        url: "/booking-rating",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/booking-rating.html",
                                controller: 'BookingRateCtrl'
                            }
                        }
                    })


                    //Service Request
                    .state('app.request', {
                        url: "/request",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/request.html",
                                controller: 'RequestCtrl'
                            }
                        }
                    })

                    //Request Bids + confirm request
                    .state('app.request-bid', {
                        url: "/request-bid",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/request-bid.html",
                                controller: 'RequestBidCtrl'
                            }
                        }
                    })

                    //Post Request
                    .state('app.send-request', {
                        url: "/send-request",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/send-request.html",
                                controller: 'SendRequestCtrl'
                            }
                        }
                    })


                    //Order
                    .state('app.order', {
                        url: "/order",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/order.html",
                                controller: 'OrderCtrl'
                            }
                        }
                    })

                    .state('app.order-product', {
                        url: "/order-product",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/order-product.html",
                                controller: 'OrderProductCtrl'
                            }
                        }
                    })

                    //Save Rating
                    .state('app.order-rating', {
                        url: "/order-rating",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/order-rating.html",
                                controller: 'OrderRateCtrl'
                            }
                        }
                    })
                    
                    //get Report
                    .state('app.report', {
                        url: "/report",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/report.html",
                                controller: 'ReportCtrl'
                            }
                        }
                    })
                    
                    .state('app.reportAppointments', {
                        url: "/reportAppointments/:dateFrom/:dateTo",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/report-appointment.html",
                                controller: 'ReportAppointmentCtrl'
                            }
                        }
                    })
                    
                    .state('app.reportClicks', {
                        url: "/reportClick/:dateFrom/:dateTo",
                        cache: false,
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/report-click.html",
                                controller: 'ReportClickCtrl'
                            }
                        }
                    })



                    //Profile

                    .state('app.profile', {
                        url: "/profile",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/profile.html",
                                controller: 'ProfileCtrl'
                            }
                        }
                    })

                    .state('app.profile2', {
                        url: "/profile2",
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/profile.html"
                            }
                        }
                    })


//authentication
                    .state('auth.walkthrough', {
                        url: '/walkthrough',
                        templateUrl: "views/auth/walkthrough.html"
                    })

                    .state('auth.login', {
                        url: '/login',
                        templateUrl: "views/auth/login.html",
                        controller: 'LoginCtrl'
                    })

                    .state('app.do-login', {
                        url: '/do-login',
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/do-login.html",
                                controller: 'DoLoginCtrl'
                            }
                        }
                    })
                    
                    .state('app.payment',{
                        url: '/payment',
                        views: {
                            'menuContent': {
                                templateUrl: "views/app/user/payment.html",
                                controller: 'PaymentCtrl'
                            }
                        }
                    })

                    /*
                     .state('app.login', {
                     url: '/login',
                     views: {
                     'menuContent': {
                     templateUrl: "views/auth/login.html",
                     controller: 'LoginCtrl'
                     }
                     }
                     })*/

                    .state('auth.signup', {
                        url: '/signup',
                        templateUrl: "views/auth/signup.html",
                        controller: 'SignupCtrl'
                    })

                    .state('auth.forgot-password', {
                        url: "/forgot-password",
                        templateUrl: "views/auth/forgot-password.html",
                        controller: 'ForgotPasswordCtrl'
                    })

                    ;
            // if none of the above states are matched, use this as the fallback
            $urlRouterProvider.otherwise('auth/login');
        });

app.constant('$ionicLoadingConfig', {
    template: '<ion-spinner class="spinner-assertive" icon="crescent"></ion-spinner>',
    hideOnStateChange: true,
    duration: 10000
});

//Disable Ajax caching
app.config(['$httpProvider', function ($httpProvider) {
        // disable http caching
        $httpProvider.defaults.cache = false;
    }]);