angular.module('your_app_name.controllers', [])

        .controller('AuthCtrl', function ($scope, $rootScope, $state, $ionicConfig, $ionicPopup, $ionicLoading, $localstorage, UserService) {

            //Check User Already Logged In
            var user = $localstorage.getObject('user');
            if (user !== undefined && user.user_id !== undefined) {
                if (user.business_type == "3") {
                    $state.go('app.do-login');
                } else {
                    //Checked payment status in Scheduler as well
                    $ionicLoading.show();
                    UserService.getPaymentStatus(user.user_id).then(function (data) {
                        var paymentStatus = data.offer[0].payment_status;
                        if (paymentStatus == "1") {
                            $state.go('app.scheduler');
                        } else {
                            var confirmPopup = $ionicPopup.alert({
                                title: 'Payment Due',
                                template: 'It seems that your payment is due for the month.'
                            });
                            $state.go('app.payment');
                        }
                    }).finally(function () {
                        $ionicLoading.hide();
                    });
                }
            }

            $scope.redirectSalon = function () {
                $rootScope.isSalon = true;
                $state.go('app.location');
            };
            $scope.redirectFashion = function () {
                $rootScope.isSalon = false;
                $state.go('app.location');
            };
        })

// APP
        .controller('AppCtrl', function ($scope, $rootScope, $ionicConfig, $localstorage, $state, $ionicHistory, $cordovaSocialSharing) {
            $rootScope.isAuthorized = false;
            $scope.shownFilter = '';

            var user = $localstorage.getObject('user');

            $scope.isFashion = user.business_type == "3" ? true : false;
            $scope.isMobile = user.business_type == "2" ? true : false;



            $scope.$on('$ionicView.enter', function () {
                checkUser();
            });

            $scope.signout = function () {
                $localstorage.setObject('user', '');
                checkUser();
                $ionicHistory.clearCache().then(function () {
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $state.go('auth.login');
                });
            };

            $scope.share = function () {
                //window.plugins.socialsharing.share('Check my service here: ', null, null, "http://www.pamperbook.co.uk/salon/" + user.user_id);
                var options = {
                    message: 'Check my services here ', // not supported on some apps (Facebook, Instagram)
                    subject: 'Check my services here', // fi. for email
                    //files: ['', ''], // an array of filenames either locally or remotely
                    url: 'http://www.pamperbook.co.uk/salon/' + user.user_id
                            //chooserTitle: 'Pick an app' // Android only, you can override the default share sheet title
                };

                var onSuccess = function (result) {
                    console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
                    console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
                };

                var onError = function (msg) {
                    console.log("Sharing failed with message: " + msg);
                };

                $cordovaSocialSharing.share('Check my services here ', 'Check my services here ', [], 'http://www.pamperbook.co.uk/salon/' + user.user_id).then(function (result) {
                    onSuccess(result);
                }, function (err) {
                    onError(err);
                });
            };

            function checkUser() {
                $scope.user = $localstorage.getObject('user');
                $scope.isLoggedin = $scope.user.user_id !== undefined ? true : false;
            }

            $scope.reAuthorize = function () {
                $rootScope.isAuthorized = false;
            };

            $scope.isFilterShown = function (filter) {
                return $scope.shownFilter === filter;
            };

            $scope.toggleFilter = function (filter) {
                if ($scope.isFilterShown(filter)) {
                    $scope.shownFilter = null;
                } else {
                    $scope.shownFilter = filter;
                }
            };

        })

        .controller('LocationCtrl', function ($scope, $rootScope, $ionicPopup, $state, $ionicConfig, $ionicLoading, $ionicSideMenuDelegate, UserLocation) {

            $scope.search = {Keyword: ''};
            $scope.isLocationSelected = false;
            var selectionMarker = null;
            var userMapMarker = new google.maps.Marker(); // represents UserLocation Marker (Blue Marker)
            initMap();
            initLocationSearchBox();
            //locationPopup();

            //Disable Swipe Sidemenu while we are using map so it doesn't confilict with map drag
            $scope.$on('$ionicView.enter', function () {
                $ionicSideMenuDelegate.canDragContent(false);
                google.maps.event.trigger(map, 'resize');
            });
            //Enable Swipe Sidemenu while we are leaving map page
            $scope.$on('$ionicView.leave', function () {
                $ionicSideMenuDelegate.canDragContent(true);
            });

            function initMap() {
                $ionicLoading.show();
                var mapOptions = {
                    center: new google.maps.LatLng(53.4361891, -3.1312662),
                    zoom: 7,
                    mapTypeId: google.maps.MapTypeId.ROADMAP,
                    disableDefaultUI: true
                };

                map = new google.maps.Map(document.getElementById("map"), mapOptions);

                UserLocation.getMyLocation().then(function (position) {
                    salonCart.geoLocation.lat = Math.round(position.coords.latitude * 10000000) / 10000000;
                    salonCart.geoLocation.long = Math.round(position.coords.longitude * 10000000) / 10000000;
                    userLocationMarker();
                }).catch(function (e) {
                    //if location not Found
                    locationPopup();
                }).finally(function () {
                    $ionicLoading.hide();
                });

            }

            function initLocationSearchBox() {

                var input = (document.getElementById('pac-input'));
                //clear all the previous event binded with SearchBox input
                google.maps.event.clearInstanceListeners(input);

                /*Code for Fake Location*/
                var searchBox = new google.maps.places.SearchBox(input);

                // Bias the SearchBox results towards current map's viewport.
                map.addListener('bounds_changed', function () {
                    searchBox.setBounds(map.getBounds());
                });

                //google.maps.event.clearListeners(searchBox, 'places_changed');
                // Listen for the event fired when the user selects a prediction and retrieve
                // more details for that place.
                searchBox.addListener('places_changed', function () {

                    $ionicLoading.show();

                    var places = searchBox.getPlaces();

                    if (places.length === 0 || places[0].geometry === undefined) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: "Location Not Found",
                            content: "Sorry ! We cannot find that location.",
                            okType: 'button-stable'
                        });
                        return;
                    }

                    // Clear out the old user markers.
                    userMapMarker.setMap(null);

                    //reset Bounds for new marker
                    //bounds = new google.maps.LatLngBounds();

                    // For each place, get the icon, name and location.
                    var place = places[0];

                    // set the new geolocation globally so that Search criteria can work on new geolocation
                    salonCart.geoLocation.lat = Math.round(place.geometry.location.lat() * 10000000) / 10000000;
                    salonCart.geoLocation.long = Math.round(place.geometry.location.lng() * 10000000) / 10000000;

                    //create userlocation marker based on new geolocation
                    userLocationMarker();
                    $ionicLoading.hide();

                });
            }

            function userLocationMarker() {

                var markerPos = new google.maps.LatLng(salonCart.geoLocation.lat, salonCart.geoLocation.long);
                var image = 'img/ic_map_mylocation.png';
                // Add the markerto the map
                userMapMarker = new google.maps.Marker({
                    map: map,
                    animation: google.maps.Animation.DROP,
                    position: markerPos,
                    icon: image
                });
                //Zoom to User Location
                map.panTo(userMapMarker.getPosition());
                $scope.isLocationSelected = true;
                //bounds.extend(markerPos);
            }


            $scope.clearSearch = function () {
                disableTap();
                $scope.search.Keyword = '';
                $scope.isLocationSelected = false;
            };

            function locationPopup() {
                $ionicPopup.alert({
                    title: "Location",
                    content: "Please Enter your location to get you near by Services."
                            //okType: 'button-dark'
                });
            }

            $scope.moveNext = function () {
                if ($scope.search.Keyword === '' && salonCart.geoLocation.lat === '')
                {
                    $scope.isLocationSelected = false;
                    locationPopup();
                } else {
                    if ($rootScope.isSalon) {
                        $rootScope.location = $scope.search.Keyword;
                        $state.go('app.treatment');
                    } else {
                        $state.go('app.fashion-list');
                    }
                }
            };

        })
//Salon
        .controller('TreatmentCtrl', function ($scope, $rootScope, $state, $ionicConfig, $ionicLoading, TreatmentService) {
            $scope.treatmentList = [];
            $scope.data = {treatment: ''};
            $ionicLoading.show();
            TreatmentService.getTreatmentList().then(function (data) {
                $scope.treatmentList = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.setService = function (serviceID) {
                //$rootScope.serviceID = serviceID;
                $state.go('app.salon-list', {serviceID: serviceID});
            };

        })

        .controller('SalonReviewCtrl', function ($scope, $stateParams, SalonService, $ionicLoading) {
            var salonID = $stateParams.salonId;
            $scope.reviews = [];
            $ionicLoading.show();
            SalonService.getSalonReviewList(salonID).then(function (data) {
                $scope.reviews = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

        })

//User Account

        .controller('SalonSearchCtrl', function ($scope, $rootScope, $stateParams, $ionicScrollDelegate, $ionicConfig, SalonService, $ionicLoading, $timeout, $state) {
            $scope.salonList = [];
            $scope.moreDataCanBeLoaded = true;
            var startIndex = 0;
            var noOfRecords = 5;


            $scope.search = {keyword: ''};

            //$scope.loadMoreData = function () {
            $scope.searchSalon = function () {
                $ionicLoading.show();
                SalonService.searchSalon($scope.search.keyword).then(function (data) {
                    //Check if Data is Empty, stop calling api
                    if (data.length === 0) {
                        $scope.moreDataCanBeLoaded = false;
                    } else {
                        $scope.salonList = $scope.salonList.concat(data);
                        startIndex += noOfRecords;
                        $ionicScrollDelegate.resize();
                        $scope.$broadcast('scroll.infiniteScrollComplete');
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };
            //};

            $scope.getServiceList = function (objSalon) {
                //clear Cart if Different Salons
                if (salonCart.salon.id !== objSalon.id) {
                    clearCart();
                }
                salonCart.salon = objSalon;
                $state.go('app.salon', {salonId: objSalon.id});
            };

        })

        .controller('BookingCtrl', function ($scope, $rootScope, AppointmentService, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.pendingAppts = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            AppointmentService.getToday($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.pendingAppts = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function (objAppt) {
                $rootScope.Appt = objAppt;
                $state.go('app.appointment');
            };

        })

        .controller('PendingCtrl', function ($scope, $rootScope, AppointmentService, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.pendingAppts = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            AppointmentService.getPending($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.pendingAppts = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function (objAppt) {
                $rootScope.Appt = objAppt;
                $state.go('app.appointment');
            };

        })

        .controller('UpcomingCtrl', function ($scope, $rootScope, AppointmentService, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.pendingAppts = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            AppointmentService.getUpcoming($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.pendingAppts = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function (objAppt) {
                $rootScope.Appt = objAppt;
                $state.go('app.appointment');
            };

        })

        .controller('CustomerCtrl', function ($scope, $rootScope, ViewDetail, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.viewCust = [];
            $scope.data = {customer: ''};
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            ViewDetail.getCustomer($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.viewCust = data.offer;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.updateCustomer = function (objCust) {
                $rootScope.customerDtl = objCust;
                $state.go('app.editCustomer');
            };

        })

        .controller('StaffCtrl', function ($scope, $rootScope, ViewDetail, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.viewStaff = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            ViewDetail.getStaff($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.viewStaff = data.offer;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.updateStaff = function (objStaff) {
                $rootScope.StaffDtl = objStaff;
                $state.go('app.editStaff');
            };

            $scope.service = function (objStaff) {
                $rootScope.StaffDtl = objStaff;
                $state.go('app.staffService');
            };

        })

        .controller('BudgetBookingCtrl', function ($scope, $rootScope, ViewDetail, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.viewBudgetBooking = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            ViewDetail.getBudgetBooking($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.viewBudgetBooking = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.addBid = function (objBooking) {
                $rootScope.budgetBooking = objBooking;
                $state.go('app.addBookingBid');
            };
        })

        .controller('SpecialOfferCtrl', function ($scope, $rootScope, ViewDetail, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.viewSpecialOffer = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            ViewDetail.getSpecialOffer($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.viewSpecialOffer = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.editOffer = function (objOffer) {
                $rootScope.specialOffer = objOffer;
                $state.go('app.editSpecialOffer');
            };
        })

        .controller('AppointmentCtrl', function ($scope, $rootScope, AppointmentService, $ionicLoading, $state, $ionicPopup, $ionicHistory) {
            $scope.total = 0;

            $scope.Appt = $rootScope.Appt;
            $scope.services = [];

            $scope.isReject = true;
            $scope.isApprove = false;
            $scope.isComplete = false;

            if ($scope.Appt.status == '0') {
                $scope.isApprove = true;
            }

            if ($scope.Appt.status == '1') {
                $scope.isComplete = true;
            }

            $scope.rating = {};
            $scope.rating.rate = 3;
            $scope.rating.max = 5;

            $scope.getMinute = function (timeStr) {
                return getMinute(timeStr);
            };

            $ionicLoading.show();
            AppointmentService.getServices($scope.Appt.id).then(function (data) {
                $scope.services = data;
                $scope.calcTotal();
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.calcTotal = function () {
                $scope.total = parseInt('0');
                angular.forEach($scope.services, function (service, key) {
                    $scope.total += parseFloat(service.price);
                });
            };

            $scope.approve = function () {
                $ionicLoading.show();
                AppointmentService.approveService($scope.Appt.id).then(function (data) {
                    if (data.statusCode === 200) {
                        $ionicPopup.alert({
                            title: 'Sucess!',
                            template: 'Appointment Approved'
                        });
                        $ionicHistory.goBack(-1);
                    } else {
                        $ionicPopup.alert({
                            title: 'Failed!',
                            template: 'Please try again'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };

            $scope.reject = function () {
                $ionicLoading.show();
                AppointmentService.rejectService($scope.Appt.id).then(function (data) {
                    if (data.statusCode === 200) {
                        $ionicPopup.alert({
                            title: 'Sucess!',
                            template: 'Appointment Rejected'
                        });
                        $ionicHistory.goBack(-1);
                    } else {
                        $ionicPopup.alert({
                            title: 'Failed!',
                            template: 'Please try again'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };

            $scope.complete = function () {
                $ionicLoading.show();
                AppointmentService.completeService($scope.Appt.id).then(function (data) {
                    if (data.statusCode === 200) {
                        $ionicPopup.alert({
                            title: 'Sucess!',
                            template: 'Appointment Complete'
                        });
                        $ionicHistory.goBack(-1);
                    } else {
                        $ionicPopup.alert({
                            title: 'Failed!',
                            template: 'Please try again'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };

            //api/reject-appointment/appointmentid | 0,1
            //api/approveService/appointmentid | 0
            //api/completeService/appointmentid | 1

            $scope.rateIt = function () {
                $state.go('app.booking-rating');
            };

        })

        .controller('BookingRateCtrl', function ($scope, $rootScope, AppointmentService, $ionicLoading, $state, $localstorage, $ionicHistory) {
            $scope.Appt = $rootScope.Appt;

            $scope.rating = {};
            $scope.rating.rate = 1;
            $scope.rating.max = 5;

            $scope.user = $localstorage.getObject('user');

            $scope.submit = function () {
                $ionicLoading.show();
                AppointmentService.saveReview($scope.Appt.id, $scope.Appt.salon_id, $scope.user.id, $scope.rating.rate, $scope.rating.description).then(function (data) {

                    $ionicHistory.clearCache().then(function () {
                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });
                        $state.go('app.booking');
                    });
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };

        })

        .controller('OrderCtrl', function ($scope, $rootScope, OrderService, $ionicLoading, $localstorage, $state) {
            $scope.noPending = false;
            $scope.noUpcoming = false;
            $scope.noCompleted = false;
            $scope.pendingOrders = [];
            $scope.upcomingOrders = [];
            $scope.completedOrders = [];
            $scope.user = $localstorage.getObject('user');

            $scope.rating = {};
            $scope.rating.rate = 3;
            $scope.rating.max = 5;

            $ionicLoading.show();
            OrderService.getPending($scope.user.id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.pendingOrders = data;
            });

            OrderService.getUpcoming($scope.user.id).then(function (data) {
                if (data.length === 0) {
                    $scope.noUpcoming = true;
                }
                $scope.upcomingOrders = data;
            });

            OrderService.getCompleted($scope.user.id).then(function (data) {
                if (data.length === 0) {
                    $scope.noCompleted = true;
                }
                $scope.completedOrders = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getProduct = function (objorder) {
                $rootScope.Order = objorder;
                $state.go('app.order-product');
            };
        })

        .controller('OrderProductCtrl', function ($scope, $rootScope, OrderService, $ionicLoading, $state) {
            $scope.total = 0;

            $scope.Order = $rootScope.Order;
            $scope.services = [];

            $scope.rating = {};
            $scope.rating.rate = 3;
            $scope.rating.max = 5;

            $ionicLoading.show();
            OrderService.getServices($scope.Order.id).then(function (data) {
                $scope.services = data;
                $scope.calcTotal();
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.calcTotal = function () {
                $scope.total = parseInt('0');
                angular.forEach($scope.services, function (service, key) {
                    $scope.total += parseFloat(service.sales_price);
                });
            };

            $scope.rateIt = function () {
                $state.go('app.order-rating');
            };
        })

        .controller('OrderRateCtrl', function ($scope, $rootScope, OrderService, $ionicLoading, $state, $localstorage, $ionicHistory) {
            $scope.Order = $rootScope.Order;

            $scope.rating = {};
            $scope.rating.rate = 1;
            $scope.rating.max = 5;

            $scope.user = $localstorage.getObject('user');

            $scope.submit = function () {
                $ionicLoading.show();
                OrderService.saveReview($scope.Order.id, $scope.Order.salon_id, $scope.user.id, $scope.rating.rate, $scope.rating.description).then(function (data) {
                    //clear cache and redirect to load Fresh Data
                    $ionicHistory.clearCache().then(function () {
                        $ionicHistory.nextViewOptions({
                            disableBack: true
                        });
                        $state.go('app.order');
                    });
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };

        })

        .controller('AddCustomerCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.r1 = "Female";

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addCustomer($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Well done! New customer added.'
                            });
                            $state.go('app.customer');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('EditCustomerCtrl', function ($scope, $state, PanelService, $rootScope, $filter, $localstorage, $ionicPopup) {
            $scope.data = $rootScope.customerDtl;
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.r1 = $rootScope.customerDtl.gender;
            $scope.data.user_id = $rootScope.customerDtl.id;
            $scope.data.name = $rootScope.customerDtl.full_name;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.editCustomer($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Updated Successfully!'
                            });
                            $state.go('app.customer');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.deleteData = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        PanelService.deleteCustomer($scope.data.user_id).then(function (data) {
                            console.log(data);
                            if (data.statusCode === 200) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Successfull!',
                                    template: 'Data Deleted Successfully!'
                                });
                                $state.go('app.customer');
                            } else {
                                $ionicPopup.alert({
                                    title: 'failed!',
                                    template: 'Please try again!'
                                });
                            }
                        });
                    }
                });

            };

        })


        .controller('AddStaffCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addStaff($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.staff');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('EditStaffCtrl', function ($scope, $state, PanelService, $rootScope, $filter, $localstorage, $ionicPopup) {
            $scope.data = $rootScope.StaffDtl;
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.member_id = $rootScope.StaffDtl.id;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.editStaff($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.staff');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.deleteData = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        PanelService.deleteStaff($scope.data.member_id).then(function (data) {
                            console.log(data);
                            if (data.statusCode === 200) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Successfull!',
                                    template: 'Data Deleted Successfully!'
                                });
                                $state.go('app.staff');
                            } else {
                                $ionicPopup.alert({
                                    title: 'failed!',
                                    template: 'Please try again!'
                                });
                            }
                        });
                    }
                });

            };
        })

        .controller('StaffServiceCtrl', function ($scope, $state, PanelService, $rootScope, $filter, $localstorage, $ionicPopup, $ionicLoading) {
            $scope.data = $rootScope.StaffDtl;
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.staff_id = $rootScope.StaffDtl.id;

            $ionicLoading.show();
            PanelService.getStaffServices($scope.user.user_id, $scope.data.id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.serviceList = data.offer.offer;
                var staffService = data.offer.staffService;

                angular.forEach($scope.serviceList, function (value1, key1) {
                    angular.forEach(staffService, function (value2, key2) {
                        if (value1.id === value2.service_id) {
                            // here is where you grab the value2.color
                            $scope.serviceList[key1].checked = true;
                        }
                    });
                });

            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.saveData = function () {
                var staff = [];
                angular.forEach($scope.serviceList, function (obj, key1) {
                    if (obj.checked === true) {
                        staff.push(obj.id);
                    }
                });
                console.log(staff);
                $scope.data.staff = staff;
                PanelService.addStaffService($scope.data).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Successfull!',
                            template: 'Data Saved Successfully!'
                        });
                        $state.go('app.staff');
                    } else {
                        $ionicPopup.alert({
                            title: 'failed!',
                            template: 'Please try again!'
                        });
                    }
                });

            };

        })

        .controller('AddBookingBidCtrl', function ($scope, $state, PanelService, $rootScope, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.objBooking = $rootScope.budgetBooking;
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.request_id = $scope.objBooking.id;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addBookingBid($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.budgetBooking');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('ViewSelectedBookingCtrl', function ($scope, $rootScope, PanelService, $ionicLoading, $localstorage, $state) {
            $scope.noData = false;
            $scope.dataList = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            PanelService.viewSelectedBooking($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.dataList = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.addBid = function (objBooking) {
                $rootScope.budgetBooking = objBooking;
                $state.go('app.addBookingBid');
            };

        })

        .controller('ViewServiceCtrl', function ($scope, $rootScope, PanelService, $ionicLoading, $localstorage, $state) {
            $scope.noData = false;
            $scope.dataList = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            PanelService.viewService($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.dataList = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function (objAppt) {
                $rootScope.service = objAppt;
                $state.go('app.serviceDetail');
            };

        })

        .controller('ServiceDetailCtrl', function ($scope, $rootScope, PanelService, TreatmentService, $ionicLoading, $localstorage, $state, $filter, $ionicPopup) {
            $scope.noData = false;
            $scope.data = $rootScope.service;
            $scope.user = $localstorage.getObject('user');
            $scope.data.rate = $rootScope.service.price;
            $scope.data.discount = $rootScope.service.offer_price;

            $ionicLoading.show();
            TreatmentService.getTreatmentList().then(function (data) {
                $scope.treatmentList = data;
                $scope.data.category = $scope.data.category_id;
                $scope.getService();
                $scope.data.service = $scope.data.service_id;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function () {
                var objCat = $filter('filter')($scope.treatmentList, function (d) {
                    return d.category_id == $scope.data.category;
                })[0];
                $scope.serviceList = objCat.services;
                $scope.data.service = $scope.serviceList[0].id;
            };

            $scope.saveData = function (form) {
                if (form.$valid) {
                    $scope.data.service_id = $rootScope.service.id;
                    PanelService.editService($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.viewService');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.deleteData = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        PanelService.deleteService($rootScope.service.id).then(function (data) {
                            console.log(data);
                            if (data.statusCode === 200) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Successfull!',
                                    template: 'Data Deleted Successfully!'
                                });
                                $state.go('app.viewService');
                            } else {
                                $ionicPopup.alert({
                                    title: 'failed!',
                                    template: 'Please try again!'
                                });
                            }
                        });
                    }
                });

            };


        })

        .controller('AddServiceCtrl', function ($scope, $state, PanelService, TreatmentService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.treatmentList = [];

            $ionicLoading.show();
            TreatmentService.getTreatmentList().then(function (data) {
                $scope.treatmentList = data;
                $scope.data.category = data[0].category_id;
                $scope.getService();
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.getService = function () {
                var objCat = $filter('filter')($scope.treatmentList, function (d) {
                    return d.category_id == $scope.data.category;
                })[0];
                $scope.serviceList = objCat.services;
                $scope.data.service = $scope.serviceList[0].id;
            };

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addService($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.viewService');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('AddNewServiceCtrl', function ($scope, $state, PanelService, TreatmentService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $ionicLoading.show();
            TreatmentService.getTreatmentList().then(function (data) {
                $scope.treatmentList = data;
                $scope.data.category = data[0].category_id;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addNewService($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.viewService');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('SaveSocialLinkCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $ionicLoading.show();
            PanelService.viewSocialLink($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.data = data[0];
                $scope.data.salonId = $scope.user.user_id;
            }).finally(function () {
                $ionicLoading.hide();
            });


            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.saveSocialLink($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.request');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('AddSpecialOfferCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addSpecialOffer($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.specialOffer');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.onezoneDatepicker = {
                date: new Date(), // MANDATORY                     
                startDate: '+0d',
                disablePastDays: true,
                showDatepicker: false,
                hideSetButton: true,
                callback: function (value) {
                    $scope.data.date = $filter('date')(value, 'dd-MM-yyyy');
                }
            };
        })

        .controller('EditSpecialOfferCtrl', function ($scope, $state, PanelService, $ionicLoading, $rootScope, $filter, $localstorage, $ionicPopup) {
            $scope.data = $rootScope.specialOffer;
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.data.offer_title = $rootScope.specialOffer.service;
            $scope.data.offer_id = $rootScope.specialOffer.id;

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.editSpecialOffer($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.specialOffer');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.deleteData = function () {
                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        PanelService.deleteSpecialOffer($scope.data.offer_id).then(function (data) {
                            console.log(data);
                            if (data.statusCode === 200) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Successfull!',
                                    template: 'Data Deleted Successfully!'
                                });
                                $state.go('app.specialOffer');
                            } else {
                                $ionicPopup.alert({
                                    title: 'failed!',
                                    template: 'Please try again!'
                                });
                            }
                        });
                    }
                });

            };

            $scope.onezoneDatepicker = {
                date: new Date($rootScope.specialOffer.offer_valid_till * 1000), // MANDATORY                     
                startDate: '+0d',
                disablePastDays: true,
                showDatepicker: false,
                hideSetButton: true,
                callback: function (value) {
                    $scope.data.date = $filter('date')(value, 'dd-MM-yyyy');
                }
            };
        })

        .controller('AddProfileCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $scope.isMobile = $scope.user.business_type == "2" ? true : false;

            $ionicLoading.show();
            PanelService.viewProfile($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.data = data[0];
                $scope.data.salonId = $scope.user.user_id;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addProfile($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.request');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('AddLocationCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            initLocationSearchBox();

            $ionicLoading.show();
            PanelService.viewLocation($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.data = data[0];
                $scope.data.salonId = $scope.user.user_id;
            }).finally(function () {
                $ionicLoading.hide();
            });


            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addLocation($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.addLocation');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            function initLocationSearchBox() {

                var input = (document.getElementById('location'));
                //clear all the previous event binded with SearchBox input
                google.maps.event.clearInstanceListeners(input);

                /*Code for Fake Location*/
                var searchBox = new google.maps.places.SearchBox(input);

                // Bias the SearchBox results towards current map's viewport.
                /* map.addListener('bounds_changed', function () {
                 searchBox.setBounds(map.getBounds());
                 });*/

                //google.maps.event.clearListeners(searchBox, 'places_changed');
                // Listen for the event fired when the user selects a prediction and retrieve
                // more details for that place.
                searchBox.addListener('places_changed', function () {

                    var places = searchBox.getPlaces();

                    if (places.length === 0 || places[0].geometry === undefined) {
                        $ionicLoading.hide();
                        $ionicPopup.alert({
                            title: "Location Not Found",
                            content: "Sorry ! We cannot find that location.",
                            okType: 'button-stable'
                        });
                        return;
                    }


                    //reset Bounds for new marker
                    //bounds = new google.maps.LatLngBounds();

                    // For each place, get the icon, name and location.
                    var place = places[0];

                    // set the new geolocation globally so that Search criteria can work on new geolocation
                    $scope.data.latitude = Math.round(place.geometry.location.lat() * 10000000) / 10000000;
                    $scope.data.longitude = Math.round(place.geometry.location.lng() * 10000000) / 10000000;
                    $scope.data.address = String(place.adr_address).replace(/<[^>]+>/gm, '');
                });
            }

            $scope.clearSearch = function () {
                disableTap();
                $scope.data.location = '';
            };
        })

        .controller('AddCustomerDiscountCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;

            $ionicLoading.show();
            PanelService.viewCustomerDiscount($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.data = data[0];
                $scope.data.salonId = $scope.user.user_id;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addCustomerDiscount($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.addCustomerDiscount');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('AddOpeningTimeCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, ionicTimePicker, $localstorage, $ionicPopup) {
            $scope.data = {};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            var dateElement = '';
            var days = ["sunday", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday"];

            $ionicLoading.show();
            PanelService.viewOpeningTime($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                angular.forEach(data, function (objTime, key) {
                    var fromStr = days[objTime.type] + "from";
                    var toStr = days[objTime.type] + "to";
                    $scope.data[fromStr] = objTime.from_time;
                    $scope.data[toStr] = objTime.to_time;
                });

                //$scope.dataList = data;
            }).finally(function () {
                $ionicLoading.hide();
            });


            $scope.saveData = function (form) {
                if (form.$valid) {
                    PanelService.addOpeningTime($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.addOpeningTime');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            var ipObj1 = {
                callback: function (val) {      //Mandatory
                    if (typeof (val) === 'undefined') {
                        console.log('Time not selected');
                    } else {
                        var selectedTime = new Date(val * 1000);
                        console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), 'H :', selectedTime.getUTCMinutes(), 'M');
                        $scope.data[dateElement] = moment(selectedTime).format('HH:mm');//selectedTime.getUTCHours() + ":" + selectedTime.getUTCMinutes();
                    }
                },
                inputTime: 32400, //Optional
                format: 24, //Optional
                step: 30, //Optional
                setLabel: 'Done'    //Optional
            };

            $scope.setTime = function (objElement) {
                dateElement = objElement;
                ionicTimePicker.openTimePicker(ipObj1);
            };


        })

        .controller('UnavailableCtrl', function ($scope, $rootScope, PanelService, $ionicLoading, $localstorage, $state, $ionicPopup) {
            $scope.noPending = false;
            $scope.unavailableStaff = [];
            $scope.user = $localstorage.getObject('user');

            $ionicLoading.show();
            PanelService.getStaffUnavailableTime($scope.user.user_id).then(function (data) {
                if (data === 0) {
                    $scope.noPending = true;
                }
                $scope.unavailableStaff = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.delete = function (objStaff) {

                var confirmPopup = $ionicPopup.confirm({
                    title: 'Delete',
                    template: 'Are you sure?'
                });
                confirmPopup.then(function (res) {
                    if (res) {
                        PanelService.makeStaffAvailableTime(objStaff.id).then(function (data) {
                            console.log(data);
                            if (data.statusCode === 200) {
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Successfull!',
                                    template: 'Data Deleted Successfully!'
                                });
                                $state.go($state.current, {}, {reload: true});
                            } else {
                                $ionicPopup.alert({
                                    title: 'failed!',
                                    template: 'Please try again!'
                                });
                            }
                        });
                    }
                });

            };

        })

        .controller('AddAppointmentCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup, ViewDetail, ionicTimePicker) {
            $scope.data = {customer: null};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salonId = $scope.user.user_id;
            $scope.customerList = [];
            $scope.newCustFlag = false;
            $scope.data.date = $state.params.objDate !== null ? $state.params.objDate : new Date();
            $scope.data.time = $state.params.objDate !== null ? moment($state.params.objDate).format('HH:mm') : '';

            $ionicLoading.show();
            ViewDetail.getCustomer($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.customerList = data.offer;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $ionicLoading.show();
            PanelService.viewService($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noData = true;
                }
                $scope.serviceList = data;
            }).finally(function () {
                $ionicLoading.hide();
            });

            $ionicLoading.show();
            ViewDetail.getStaff($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.staffList = data.offer;

                if ($state.params.objStaff !== null) {
                    //$scope.data.member_id = parseInt($state.params.objStaff.id, 10);
                    $scope.data.member_id = $state.params.objStaff.id;
                }
            }).finally(function () {
                $ionicLoading.hide();
            });

            $scope.onezoneDatepicker = {
                date: new Date(), // MANDATORY                     
                startDate: '+0d',
                endDate: '+7d',
                disablePastDays: true,
                //showDatepicker: true,
                //calendarMode: true,
                hideSetButton: true,
                callback: function (value) {
                    $scope.data.date = value;
                    dateTimestamp = (value.getTime()); //0-Sun, 1-Mon
                }
            };

            $scope.onezoneDatepicker.date = $scope.data.date;

            var ipObj1 = {
                callback: function (val) {      //Mandatory
                    if (typeof (val) === 'undefined') {
                        console.log('Time not selected');
                    } else {
                        var selectedTime = new Date(val * 1000);
                        console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), 'H :', selectedTime.getUTCMinutes(), 'M');
                        $scope.data.time = moment(selectedTime).format('HH:mm');//selectedTime.getUTCHours() + ":" + selectedTime.getUTCMinutes();
                    }
                },
                inputTime: 32400, //Optional
                format: 24, //Optional
                step: 30, //Optional
                setLabel: 'Done'    //Optional
            };

            $scope.setTime = function () {
                ionicTimePicker.openTimePicker(ipObj1);
            };

            $scope.saveData = function (form) {
                if (form.$valid) {
                    $scope.data.date = moment($scope.data.date).format('DD-MM-YYYY');
                    PanelService.addAppointment($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.scheduler');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.getLowestPrice = function (offerPrice, Price) {
                offerPrice = parseFloat(offerPrice);
                Price = parseFloat(Price);
                if (offerPrice < Price && offerPrice > 0) {
                    return offerPrice;
                } else {
                    return Price;
                }
            };
        })

        .controller('AddUnavailabilityCtrl', function ($scope, $state, PanelService, $ionicLoading, $filter, $localstorage, $ionicPopup, ViewDetail, ionicTimePicker) {
            $scope.data = {staff_id: ''};
            $scope.user = $localstorage.getObject('user');
            $scope.data.salon_id = $scope.user.user_id;
            $scope.data.date2 = $state.params.objDate !== null ? $state.params.objDate : new Date();
            $scope.data.time = $state.params.objDate !== null ? moment($state.params.objDate).format('HH:mm') : '';

            $ionicLoading.show();
            ViewDetail.getStaff($scope.user.user_id).then(function (data) {
                if (data.length === 0) {
                    $scope.noPending = true;
                }
                $scope.staffList = data.offer;

            }).finally(function () {
                if ($state.params.objStaff !== null) {
                    //$scope.data.staff_id = parseInt($state.params.objStaff.id, 10);
                    $scope.data.staff_id = $state.params.objStaff.id;
                }
                $ionicLoading.hide();
            });

            $scope.onezoneDatepicker = {
                date: new Date(), // MANDATORY                     
                startDate: '+0d',
                endDate: '+7d',
                disablePastDays: true,
                //showDatepicker: true,
                //calendarMode: true,
                hideSetButton: true,
                callback: function (value) {
                    $scope.data.date2 = value;
                    dateTimestamp = (value.getTime()); //0-Sun, 1-Mon
                }
            };

            $scope.onezoneDatepicker.date = $scope.data.date2;


            var dateElement = '';
            var ipObj1 = {
                callback: function (val) {      //Mandatory
                    if (typeof (val) === 'undefined') {
                        console.log('Time not selected');
                    } else {
                        var selectedTime = new Date(val * 1000);
                        console.log('Selected epoch is : ', val, 'and the time is ', selectedTime.getUTCHours(), 'H :', selectedTime.getUTCMinutes(), 'M');
                        $scope.data['time_' + dateElement] = moment(selectedTime).format('HH:mm');//selectedTime.getUTCHours() + ":" + selectedTime.getUTCMinutes();
                    }
                },
                inputTime: 32400, //Optional
                format: 24, //Optional
                step: 30, //Optional
                setLabel: 'Done'    //Optional
            };

            $scope.setTime = function (objElement) {
                dateElement = objElement;
                ionicTimePicker.openTimePicker(ipObj1);
            };

            $scope.saveData = function (form) {
                if (form.$valid) {
                    $scope.data.noton = moment($scope.data.date2).format('DD-MM-YYYY');
                    PanelService.addStaffUnavailability($scope.data).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Data Saved Successfully!'
                            });
                            $state.go('app.scheduler');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        .controller('PaymentCtrl', function ($scope, $rootScope, PanelService, $ionicLoading, $localstorage, $state, $ionicPopup) {
            $scope.noPending = false;
            $scope.unavailableStaff = [];
            $scope.user = $localstorage.getObject('user');
            $scope.inProcess = true;
            $scope.price = 'Loading...';

            $ionicLoading.show();
            PanelService.getPackagePrice().then(function (data) {
                $scope.price = data[0].package_price;
            }).finally(function () {
                $ionicLoading.hide();
            });

            var braintreeInstance = '';


            PanelService.getBraintreeToken($scope.user.user_id).then(function (data) {
                $ionicLoading.show();
                if (data === 0) {
                    $scope.noPending = true;
                }
                $scope.unavailableStaff = data;
                braintree.dropin.create({
                    authorization: data.offer,
                    container: '#dropin-container'
                }, function (createErr, instance) {
                    if (createErr) {
                        console.error(createErr);
                        return;
                    }
                    braintreeInstance = instance;
                    $scope.inProcess = false;
                    $ionicLoading.hide();
                    //button.addEventListener('click', function () {});
                });
            }).finally(function () {
                //$ionicLoading.hide();
            });

            $scope.makePayment = function () {
                $scope.inProcess = true;
                braintreeInstance.requestPaymentMethod(function (err, payload) {
                    if (err) {
                        // No payment method is available.
                        // An appropriate error will be shown in the UI.
                        console.error(err);
                        return;
                    }
                    // Submit payload.nonce to your server
                    console.log(payload);
                    var tokenData = {card_token: payload.nonce, salonId: $scope.user.user_id};

                    $ionicLoading.show();
                    PanelService.makePayment(tokenData).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Payment Successfull! Thank You.'
                            });
                            $state.go('app.scheduler');
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                            $scope.inProcess = false;
                        }
                    }).finally(function () {
                        $ionicLoading.hide();
                    });


                });
            };

        })

        .controller('ReportCtrl', function ($scope, $rootScope, PanelService, $ionicLoading, $localstorage, $state, $ionicPopup) {
            $scope.noPending = false;
            $scope.unavailableStaff = [];
            $scope.user = $localstorage.getObject('user');
            $scope.hasData = false;
            var objDate = new Date();
            $scope.data = {dateFrom: objDate, dateTo: objDate};
            $scope.data.salonId = $scope.user.user_id;
            $scope.click = {};

            $scope.onezoneDatepickerFrom = {
                date: new Date(), // MANDATORY                     
                startDate: '+0d',
                //endDate: '+7d',
                //disablePastDays: true,
                //showDatepicker: true,
                //calendarMode: true,
                hideSetButton: true,
                callback: function (value) {
                    $scope.dateFrom = value;
                }
            };

            $scope.onezoneDatepickerTo = {
                date: new Date(), // MANDATORY                     
                startDate: '+0d',
                //endDate: '+7d',
                //disablePastDays: true,
                //showDatepicker: true,
                //calendarMode: true,
                hideSetButton: true,
                callback: function (value) {
                    $scope.dateTo = value;
                }
            };

            $scope.getReport = function () {
                $scope.hasData = false;
                $scope.data.dateFrom = moment($scope.dateFrom).format('DD-MM-YYYY');
                $scope.data.dateTo = moment($scope.dateTo).format('DD-MM-YYYY');
                console.log($scope.data);
                $ionicLoading.show();
                PanelService.getReport($scope.data).then(function (data) {
                    console.log(data);
                    $scope.click = angular.fromJson(data);
                    $scope.hasData = true;
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };

            $scope.getClicks = function () {
                $scope.data.dateFrom = moment($scope.dateFrom).format('DD-MM-YYYY');
                $scope.data.dateTo = moment($scope.dateTo).format('DD-MM-YYYY');
                $state.go('app.reportClicks', {dateFrom: $scope.data.dateFrom, dateTo: $scope.data.dateTo});
            };

            $scope.getAppointments = function () {
                $scope.data.dateFrom = moment($scope.dateFrom).format('DD-MM-YYYY');
                $scope.data.dateTo = moment($scope.dateTo).format('DD-MM-YYYY');
                $state.go('app.reportAppointments', {dateFrom: $scope.data.dateFrom, dateTo: $scope.data.dateTo});
            };

        })

        .controller('ReportClickCtrl', function ($scope, $rootScope, $stateParams, PanelService, $ionicLoading, $localstorage, $state, $ionicPopup) {
            $scope.noPending = false;
            $scope.user = $localstorage.getObject('user');
            $scope.hasData = false;
            $scope.data = {dateFrom: $stateParams.dateFrom, dateTo: $stateParams.dateTo};
            $scope.data.salonId = $scope.user.user_id;
            $scope.clicks = {};

            $scope.getReport = function () {
                $scope.hasData = false;
                console.log($scope.data);
                $ionicLoading.show();
                PanelService.getClickReport($scope.data).then(function (data) {
                    console.log(data);
                    if (data.length > 0) {
                        $scope.hasData = true;
                    }
                    $scope.clicks = angular.fromJson(data);
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };

            $scope.getReport();

        })

        .controller('ReportAppointmentCtrl', function ($scope, $rootScope, $stateParams, PanelService, $ionicLoading, $localstorage, $state, $ionicPopup) {
            $scope.noPending = false;
            $scope.user = $localstorage.getObject('user');
            $scope.hasData = false;
            $scope.data = {dateFrom: $stateParams.dateFrom, dateTo: $stateParams.dateTo};
            $scope.data.salonId = $scope.user.user_id;
            $scope.clicks = {};

            $scope.getReport = function () {
                $scope.hasData = false;
                console.log($scope.data);
                $ionicLoading.show();
                PanelService.getAppointmentReport($scope.data).then(function (data) {
                    console.log(data);
                    if (data.length > 0) {
                        $scope.hasData = true;
                    }
                    $scope.clicks = angular.fromJson(data);

                }).finally(function () {
                    $ionicLoading.hide();
                });

            };

            $scope.getReport();

        })

//LOGIN
        .controller('LoginCtrl', function ($scope, $state, $ionicHistory, $templateCache, $q, $ionicLoading, $rootScope, LoginService, $ionicPopup, $localstorage, UserService) {
            $scope.user = {};


            $scope.doLogIn = function () {
                $ionicLoading.show();
                LoginService.loginUser($scope.user.email, $scope.user.password).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        $localstorage.set('userAuthToken', data.token);
                        $localstorage.setObject('user', data.user);
                        saveDeviceID(data.user.user_id);
                        //save Credential
                        $localstorage.setObject('credential', $scope.user);
                        $ionicHistory.clearCache().then(function () {
                            $ionicHistory.nextViewOptions({
                                disableBack: true
                            });
                            $state.go('app.scheduler');
                        });

                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Login failed!',
                            template: 'The Email Address/Password that you have entered is incorrect Or your account is not verified. Please try Again.'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };

            function saveDeviceID(userID) {
                var platform = ionic.Platform.platform();
                if (window.plugins !== undefined) {
                    window.plugins.OneSignal.getIds(function (ids) {
                        UserService.saveDeviceID(userID, ids.userId, platform).then(function (data) {
                            if (data.statusCode === 200) {
                                console.log(data);
                            }
                        });

                    });
                }
            }

            // We need this for the form validation
            $scope.selected_tab = "";
            $scope.$on('my-tabs-changed', function (event, data) {
                $scope.selected_tab = data.title;
            });
        })

        .controller('DoLoginCtrl', function ($scope, $state, $ionicHistory, $timeout, $templateCache, $q, $ionicLoading, $rootScope, LoginService, $ionicPopup, $localstorage, UserService) {
            $scope.user = $localstorage.getObject('credential');
            $rootScope.isAuthorized = false;
            $scope.save = function ($form) {
                $ionicLoading.show();
                LoginService.loginUser($scope.user.email, $scope.user.password).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        //save Credential
                        $localstorage.setObject('credential', $scope.user);
                        $rootScope.isAuthorized = true;
                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Failed!',
                            template: 'Connection to Server Failed. Please Reauthorize.'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };
            $timeout(function () {
//                /$scope.save();
                angular.element('#submit').trigger('click');
            });

        })

        .controller('SchedulerCtrl', function ($scope, $state, $ionicHistory, $timeout, $templateCache, $q, $ionicLoading, $rootScope, LoginService, $ionicPopup, $localstorage, UserService) {
            $scope.user = $localstorage.getObject('credential');
            $rootScope.isAuthorized = false;

            var user = $localstorage.getObject('user');
            //Checked payment status in auth ctrl as well
            $ionicLoading.show();
            UserService.getPaymentStatus(user.user_id).then(function (data) {
                var paymentStatus = data.offer[0].payment_status;
                if (paymentStatus == "1") {
                    $state.go('app.scheduler');
                } else {
                    var confirmPopup = $ionicPopup.alert({
                        title: 'Payment Due',
                        template: 'It seems that your payment is due for the month.'
                    });
                    $state.go('app.payment');
                }
            }).finally(function () {
                $ionicLoading.hide();
            });


            if ($scope.isFashion) {
                $ionicHistory.clearCache().then(function () {
                    $ionicHistory.nextViewOptions({
                        disableBack: true
                    });
                    $state.go('app.do-login');
                });
            }


            //
            $scope.save = function ($form) {
                LoginService.loginUser($scope.user.email, $scope.user.password).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        //save Credential
                        $localstorage.setObject('credential', $scope.user);
                        $rootScope.isAuthorized = true;
                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Failed!',
                            template: 'Connection to Server Failed. Please Reauthorize.'
                        });
                    }
                }).finally(function () {

                });

            };
            $timeout(function () {
                angular.element('#submit').trigger('click');
                //$ionicLoading.hide();
            });

        })

        .controller('SignupCtrl', function ($scope, $state, $ionicPopup, $ionicLoading, LoginService) {
            $scope.user = {};
            $scope.doSignUp = function () {
                $ionicLoading.show();
                LoginService.signup($scope.user).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Registration Successfull!',
                            template: 'Thanks! Please Login.'
                        });
                        $state.go('auth.login');
                    } else {
                        $ionicPopup.alert({
                            title: 'Registration failed!',
                            template: 'Please try again!'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });

            };
        })

        .controller('ForgotPasswordCtrl', function ($scope, $state, LoginService, $ionicPopup, $ionicLoading) {
            $scope.recoverPassword = function () {
                $ionicLoading.show();
                LoginService.forgotPassword($scope.user.email).then(function (data) {
                    console.log(data);
                    if (data.statusCode === 200) {
                        var alertPopup = $ionicPopup.alert({
                            title: 'Request Received',
                            template: 'Please check your email to reset your Password!'
                        });
                        $state.go('auth.login');
                    } else {
                        $ionicPopup.alert({
                            title: 'Request failed!',
                            template: 'Please check your email!'
                        });
                    }
                }).finally(function () {
                    $ionicLoading.hide();
                });
            };
            $scope.user = {};
        })

        .controller('ProfileCtrl', function ($scope, $state, $ionicPopup, UserService, $localstorage, $ionicHistory) {
            $scope.user = $localstorage.getObject('user');
            $scope.password = {user_id: $scope.user.id};

            $scope.update = function (form) {
                if (form.$valid) {
                    UserService.updateProfile($scope.user).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Your profile has been updated!'
                            });
                            //update Local object
                            $localstorage.setObject('user', $scope.user);
                            $ionicHistory.clearCache().then(function () {
                                $ionicHistory.nextViewOptions({
                                    disableBack: true
                                });
                                $state.go('app.selection');
                            });
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };

            $scope.changePass = function (form) {
                if (form.$valid) {
                    UserService.changePassword($scope.password).then(function (data) {
                        console.log(data);
                        if (data.statusCode === 200) {
                            var alertPopup = $ionicPopup.alert({
                                title: 'Successfull!',
                                template: 'Your password has been updated!'
                            });
                            //update Local object
                            $localstorage.setObject('user', $scope.user);
                            $ionicHistory.clearCache().then(function () {
                                $ionicHistory.nextViewOptions({
                                    disableBack: true
                                });
                                $state.go('app.selection');
                            });
                        } else {
                            $ionicPopup.alert({
                                title: 'failed!',
                                template: 'Please try again!'
                            });
                        }
                    });
                } else {
                    $ionicPopup.alert({
                        title: 'Error!',
                        template: 'Check your form fields for errors.'
                    });
                }
            };
        })

        ;
