angular.module('your_app_name.directives', [])

        .directive('myTabs', function () {
            return {
                restrict: 'E',
                transclude: true,
                scope: {},
                controller: function ($scope) {
                    var tabs = $scope.tabs = [];

                    $scope.select = function (tab) {
                        angular.forEach(tabs, function (tab) {
                            tab.selected = false;
                        });
                        tab.selected = true;
                        $scope.$emit('my-tabs-changed', tab);
                    };

                    this.addTab = function (tab) {
                        if (tabs.length === 0) {
                            $scope.select(tab);
                        }
                        tabs.push(tab);
                    };
                },
                templateUrl: 'views/common/my-tabs.html'
            };
        })

        .directive('myTab', function () {
            return {
                require: '^myTabs',
                restrict: 'E',
                transclude: true,
                scope: {
                    title: '@'
                },
                link: function (scope, element, attrs, tabsCtrl) {
                    tabsCtrl.addTab(scope);
                },
                templateUrl: 'views/common/my-tab.html'
            };
        })

        .directive('validPin', function ($http) {
            return {
                require: 'ngModel',
                link: function (scope, ele, attrs, c) {
                    scope.$watch(attrs.ngModel, function (pinValue) {
                        // $http({
                        // 	method: 'POST',
                        // 	url: '/api/check/' + attrs.validPin,
                        // 	data: {'pin': attrs.validPin}
                        // }).success(function(data, status, headers, cfg) {
                        // 	c.$setValidity('valid-pin', data.isValid);
                        // }).error(function(data, status, headers, cfg) {
                        // 	c.$setValidity('valid-pin', false);
                        // });
                        if (pinValue == "12345")
                        {
                            c.$setValidity('valid-pin', true);
                        }
                        else
                        {
                            c.$setValidity('valid-pin', false);
                        }
                    });
                }
            };
        })


        .directive('showHideContainer', function () {
            return {
                scope: {
                },
                controller: function ($scope, $element, $attrs) {
                    $scope.show = false;

                    $scope.toggleType = function ($event) {
                        $event.stopPropagation();
                        $event.preventDefault();

                        $scope.show = !$scope.show;

                        // Emit event
                        $scope.$broadcast("toggle-type", $scope.show);
                    };
                },
                templateUrl: 'views/common/show-hide-password.html',
                restrict: 'A',
                replace: false,
                transclude: true
            };
        })


        .directive('showHideInput', function () {
            return {
                scope: {
                },
                link: function (scope, element, attrs) {
                    // listen to event
                    scope.$on("toggle-type", function (event, show) {
                        var password_input = element[0],
                                input_type = password_input.getAttribute('type');

                        if (!show)
                        {
                            password_input.setAttribute('type', 'password');
                        }

                        if (show)
                        {
                            password_input.setAttribute('type', 'text');
                        }
                    });
                },
                require: '^showHideContainer',
                restrict: 'A',
                replace: false,
                transclude: false
            };
        })


        .directive('biggerText', function ($ionicGesture) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    $ionicGesture.on('touch', function (event) {
                        event.stopPropagation();
                        event.preventDefault();

                        var text_element = document.querySelector(attrs.biggerText),
                                root_element = document.querySelector(".menu-content"),
                                current_size_str = window.getComputedStyle(text_element, null).getPropertyValue('font-size'),
                                current_size = parseFloat(current_size_str),
                                new_size = Math.min((current_size + 2), 24),
                                new_size_str = new_size + 'px';

                        root_element.classList.remove("post-size-" + current_size_str);
                        root_element.classList.add("post-size-" + new_size_str);
                    }, element);
                }
            };
        })

        .directive('smallerText', function ($ionicGesture) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    $ionicGesture.on('touch', function (event) {
                        event.stopPropagation();
                        event.preventDefault();

                        var text_element = document.querySelector(attrs.smallerText),
                                root_element = document.querySelector(".menu-content"),
                                current_size_str = window.getComputedStyle(text_element, null).getPropertyValue('font-size'),
                                current_size = parseFloat(current_size_str),
                                new_size = Math.max((current_size - 2), 12),
                                new_size_str = new_size + 'px';

                        root_element.classList.remove("post-size-" + current_size_str);
                        root_element.classList.add("post-size-" + new_size_str);
                    }, element);
                }
            };
        })

        .directive('ionicYoutubeVideo', function ($timeout, $ionicPlatform, youtubeEmbedUtils) {
            return {
                restrict: 'E',
                scope: {
                    videoId: '@'
                },
                controller: function ($scope, $element, $attrs) {
                    $scope.playerVars = {
                        rel: 0,
                        showinfo: 0
                    };
                    $ionicPlatform.on("pause", function () {
                        var yt_ready = youtubeEmbedUtils.ready;
                        if (yt_ready)
                        {
                            $scope.yt_video.stopVideo();
                        }
                    });
                },
                templateUrl: 'views/common/ionic-youtube-video.html',
                replace: false
            };
        })

        .directive('postContent', function ($timeout, _, $compile) {
            return {
                restrict: 'A',
                scope: {},
                link: function (scope, element, attrs) {
                    /**
                     * JavaScript function to match (and return) the video Id
                     * of any valid Youtube Url, given as input string.
                     * @author: Stephan Schmitz <eyecatchup@gmail.com>
                     * @url: http://stackoverflow.com/a/10315969/624466
                     */
                    //  Ver: https://regex101.com/r/tY9jN6/1
                    function ytVidId(url) {
                        var p = /^(?:https?:\/\/)?(?:www\.)?(?:youtu\.be\/|youtube\.com\/(?:embed\/|v\/|watch\?v=|watch\?.+&v=))((\w|-){11,})(?:\S+)?$/gmi;
                        return (url.match(p)) ? RegExp.$1 : false;
                    }

                    $timeout(function () {
                        var iframes = element.find('iframe');
                        if (iframes.length > 0)
                        {
                            angular.forEach(iframes, function (i) {

                                var iframe = angular.element(i),
                                        youtube_video_id = ((iframe.length > 0) && (!_.isUndefined(iframe[0].src))) ? ytVidId(iframe[0].src) : false;
                                if (youtube_video_id !== false)
                                {
                                    // Then it's a youtube video, compile our custom directive
                                    var ionic_yt_video = $compile("<ionic-youtube-video video-id='" + youtube_video_id + "'></ionic-youtube-video>")(scope);
                                    iframe.parent().append(ionic_yt_video);
                                    iframe.remove();
                                }
                            });
                        }
                    }, 10);
                }
            };
        })

//Use this directive to open external links using inAppBrowser cordova plugin
        .directive('dynamicAnchorFix', function ($ionicGesture, $timeout, $cordovaInAppBrowser) {
            return {
                scope: {},
                link: function (scope, element, attrs) {
                    $timeout(function () {
                        var anchors = element.find('a');
                        if (anchors.length > 0)
                        {
                            angular.forEach(anchors, function (a) {

                                var anchor = angular.element(a);

                                anchor.bind('click', function (event) {
                                    event.preventDefault();
                                    event.stopPropagation();

                                    var href = event.currentTarget.href;
                                    var options = {};

                                    //inAppBrowser see documentation here: http://ngcordova.com/docs/plugins/inAppBrowser/

                                    $cordovaInAppBrowser.open(href, '_blank', options)
                                            .then(function (e) {
                                                // success
                                            })
                                            .catch(function (e) {
                                                // error
                                            });
                                });

                            });
                        }
                    }, 10);
                },
                restrict: 'A',
                replace: false,
                transclude: false
            };
        })


        .directive('multiBg', function (_) {
            return {
                scope: {
                    multiBg: '=',
                    interval: '=',
                    helperClass: '@'
                },
                controller: function ($scope, $element, $attrs) {
                    $scope.loaded = false;
                    var utils = this;

                    this.animateBg = function () {
                        // Think i have to use apply because this function is not called from this controller ($scope)
                        $scope.$apply(function () {
                            $scope.loaded = true;
                            $element.css({'background-image': 'url(' + $scope.bg_img + ')'});
                        });
                    };

                    this.setBackground = function (bg) {
                        $scope.bg_img = bg;
                    };

                    if (!_.isUndefined($scope.multiBg))
                    {
                        if (_.isArray($scope.multiBg) && ($scope.multiBg.length > 1) && !_.isUndefined($scope.interval) && _.isNumber($scope.interval))
                        {
                            // Then we need to loop through the bg images
                            utils.setBackground($scope.multiBg[0]);
                        }
                        else
                        {
                            // Then just set the multiBg image as background image
                            utils.setBackground($scope.multiBg[0]);
                        }
                    }
                },
                templateUrl: 'views/common/multi-bg.html',
                restrict: 'A',
                replace: true,
                transclude: true
            };
        })


        .directive('bg', function () {
            return {
                restrict: 'A',
                require: '^multiBg',
                scope: {
                    ngSrc: '@'
                },
                link: function (scope, element, attr, multiBgController) {
                    element.on('load', function () {
                        multiBgController.animateBg();
                    });
                }
            };
        })

        .directive('preImg', function () {
            return {
                restrict: 'E',
                transclude: true,
                scope: {
                    ratio: '@',
                    helperClass: '@'
                },
                controller: function ($scope) {
                    $scope.loaded = false;

                    this.hideSpinner = function () {
                        // Think i have to use apply because this function is not called from this controller ($scope)
                        $scope.$apply(function () {
                            $scope.loaded = true;
                        });
                    };
                },
                templateUrl: 'views/common/pre-img.html'
            };
        })

        .directive('spinnerOnLoad', function () {
            return {
                restrict: 'A',
                require: '^preImg',
                scope: {
                    ngSrc: '@'
                },
                link: function (scope, element, attr, preImgController) {
                    element.on('load', function () {
                        preImgController.hideSpinner();
                    });
                }
            };
        })

        .directive('highlighter', ['$timeout', function ($timeout) {
                return {
                    restrict: 'A',
                    scope: {
                        model: '=highlighter'
                    },
                    link: function (scope, element) {
                        scope.$watch('model', function (nv, ov) {
                            if (nv !== ov) {
                                // apply class
                                element.addClass('cart-highlight');

                                // auto remove after some delay
                                $timeout(function () {
                                    element.removeClass('cart-highlight');
                                }, 1000);
                            }
                        });
                    }
                };
            }])

        .directive('dynamicHeight', function () {
            return {
                require: ['^ionSlideBox'],
                link: function (scope, elem, attrs, slider) {
                    scope.$watch(function () {
                        return slider[0].__slider.selected();
                    }, function (val) {
                        //getting the heigh of the container that has the height of the viewport
                        var newHeight = window.getComputedStyle(elem.parents('ion-content')[0], null).getPropertyValue("height");
                        if (parseInt(newHeight) > 0) {
                            var ionScrollTag = elem.find('ion-scroll')[0];
                            ionScrollTag.style.height = newHeight;
                        }
                    });
                }
            };
        })

        .directive('autoSubmit', function ($timeout) {
            return {
                require: 'form',
                restrict: 'A',
                scope: {
                    "ngSubmit": '&',
                    "autoSubmit": '@',
                    "timeoutShow": '='
                },
                link: function (scope, iElement, iAttrs, iCtrl) {
                    var autoSubmit = parseInt(scope.autoSubmit, 10);

                    var submitTimeout = $timeout(function () {
                    }, 0);
                    var showTimeTimeout = $timeout(function () {
                    }, 0);

                    var showTime = function () {
                        scope.timeoutShow = scope.autoSubmit / 1000;
                        showTimeTimeout = $timeout(function theFull() {
                            scope.timeoutShow = scope.timeoutShow - 1;
                            if (scope.timeoutShow <= 0) {
                                scope.timeoutShow = null;
                            } else {
                                $timeout(theFull, 1000);
                            }
                        }, 1000);
                    };


                    scope.$watch(function () {
                        return iCtrl.$valid && iCtrl.$dirty;
                    }, function (val, oldVal) {
                        if (val !== oldVal && val) {
                            iCtrl.$setPristine();
                            $timeout.cancel(submitTimeout);
                            $timeout.cancel(showTimeTimeout);

                            showTime();
                            submitTimeout = $timeout(function () {
                                if (iCtrl.$valid) {
                                    scope.ngSubmit({});
                                    iCtrl.$setPristine();
                                }
                            }, autoSubmit);
                        }
                    });
                }
            };
        })

        .directive('fullCalendar', ['scheduler', function (scheduler, $state, $ionicLoading) {
                return {
                    restrict: 'A',
                    scope: {},
                    controller: function ($scope, $state, $ionicPopup, $localstorage) {

                        this.addAppointment = function (objDate, objStaff) {
                            $scope.clicked = 1;

                            var alertPopup = $ionicPopup.confirm({
                                templateUrl: 'selectionPopup.html',
                                title: 'Add',
                                scope: $scope,
                                buttons: [{
                                        text: 'OK',
                                        type: 'button-positive',
                                        onTap: function (e) {

                                        }
                                    }, {
                                        text: 'Cancel',
                                        type: 'button-default',
                                        onTap: function (e) {

                                        }
                                    }]
                            });

                            $scope.redirect = function (code) {
                                if (code === 1) {
                                    $state.go('app.addAppointment', {objDate: objDate, objStaff: objStaff});
                                } else if (code === 2) {
                                    $state.go('app.addUnavailability', {objDate: objDate, objStaff: objStaff});
                                }
                                alertPopup.close();
                            };
                        };

                        this.getSalonID = function () {
                            var user = $localstorage.getObject('user');
                            return user.user_id;
                        };
                    },
                    link: function (scope, element, attrs, ctrl) {
                        var date = new Date();
                        var d = date.getDate(),
                                m = date.getMonth(),
                                y = date.getFullYear();
                        var backgroundColor = ['#f3b8e4', '#cbf5ad', '#69c2ca', '#f7b56b', '#f3b8e4', '#cbf5ad', '#69c2ca', '#f7b56b'];
                        angular.element(element).fullCalendar({
                            //theme: true,
                            defaultView: 'agendaDay',
                            defaultDate: date,
                            editable: true,
                            selectable: true,
                            eventLimit: true, // allow "more" link when too many events
                            schedulerLicenseKey: 'CC-Attribution-NonCommercial-NoDerivatives',
                            slotLabelFormat: 'H:mm',
                            slotDuration: '00:15:00',
                            slotLabelInterval: '00:30:00',
                            eventDurationEditable: false,
                            titleFormat: 'DD/MM/YYYY',
                            height: 'auto',
                            header: {
                                left: 'prev title next',
                                right: 'agendaDay,agendaTwoDay,agendaWeek,month',
                                center: ''
                            },
                            views: {
                                agendaTwoDay: {
                                    type: 'agenda',
                                    duration: {days: 2},
                                    groupByResource: true
                                },
                                week: {
                                    // options apply to basicWeek and agendaWeek views
                                    columnFormat: 'ddd DD/MM'
                                }
                            },
                            allDaySlot: false,
                            resources: function (callback) {

                                scheduler.getStaffList(ctrl.getSalonID()).then(function (data) {
                                    var resources = [];
                                    var option = "<option value='all'>All Staff</option>";
                                    $.each(data, function (i, item) {
                                        resources.push({
                                            title: item.name,
                                            id: item.id,
                                            eventColor: backgroundColor[Math.floor(Math.random() * backgroundColor.length)],
                                            eventTextColor: "#000000"
                                        });
                                        option += "<option value='" + item.id + "'>" + item.name + "</option>";
                                    });
                                    if ($('#staffList').val() == "all") {
                                        $('#staffList').html(option);
                                    }
                                    if (data.length == 1) {
                                        $('.fc-center').hide();
                                    }
                                    callback(resources);
                                }).finally(function () {

                                });
                            },
                            events: function (start, end, timezone, callback) {
                                var events = [];
                                scheduler.viewService(ctrl.getSalonID()).then(function (data) {

                                    $.each(data, function (i, item) {
                                        events.push({
                                            title: item.service + ' By ' + item.staff_name + ' (' + (item.custname !== null ? item.custname : item.full_name) + ')',
                                            event_type: "event",
                                            email: item.email,
                                            full_name: item.full_name,
                                            phone: item.phone,
                                            price: item.price,
                                            type: item.type,
                                            custname: item.custname,
                                            custemail: item.custemail,
                                            custphone: item.custphone,
                                            id: item.appointment_service_id,
                                            appointment_id: item.id,
                                            resourceId: item.staff_id,
                                            start: new Date(item.servicetime * 1000).toISOString(), // will be parsed
                                            end: new Date((item.servicetime * 1000) + moment.duration(item.duration)).toISOString()
                                        });
                                    });

                                    scheduler.viewUnavailableTime(ctrl.getSalonID()).then(function (data) {
                                        $.each(data.offer, function (i, item) {
                                            events.push({
                                                title: "Unavailable",
                                                event_type: "Unavailable",
                                                id: item.id,
                                                appointment_id: item.id,
                                                resourceId: item.staff_id,
                                                start: new Date((item.noton * 1000) + moment.duration(item.time_from)).toISOString(), // will be parsed
                                                end: new Date((item.noton * 1000) + moment.duration(item.time_to)).toISOString(),
                                                backgroundColor: "#cacaca" //yellow
                                            });
                                        });
                                        console.log(events);
                                        callback(events);
                                    });
                                }).finally(function () {

                                });


                            },
                            eventMouseover: function (data, event, view) {
                                //tooltip = '<div class="tooltiptopicevent" style="width:auto;height:auto;background:#feb811;position:absolute;z-index:10001;padding:10px 10px 10px 10px ;  line-height: 200%;">' + 'Name ' + ': ' + data.email + '</br>' + 'start: ' + ': ' + data.start + '</div>';
                                if (data.event_type == "Unavailable") {
                                    return;
                                }
                                tooltip = '<div class="tooltiptopicevent" style="position:absolute;">' +
                                        '<div class="sal-event-info-wrapper sal-event-info-web sal-event-info-right">' +
                                        (data.type == '0' ? '<div class="type">Online Appointment</div>' : '<div class="type">Local Appointment</div>') +
                                        '<div class="client"></div>' +
                                        '<div class="phone"></div>' +
                                        '<table cellpadding="0" cellspacing="0" class="sal-hint-info">' +
                                        '<tr>' +
                                        '<th>Client</th>' +
                                        (data.type == '0' ? '<td class="date">' + data.full_name + '</td>' : '<td class="date">' + data.custname + '</td>') +
                                        '</tr>' +
                                        '<tr>' +
                                        '<th>Email</th>' +
                                        (data.type == '0' ? '<td class="duration">' + data.email + '</td>' : '<td class="duration">' + data.custemail + '</td>') +
                                        '</tr>' +
                                        '<tr class="b-package-name">' +
                                        '<th>Phone</th>' +
                                        (data.type == '0' ? '<td class="v-package-name">' + data.phone + '</td>' : '<td class="v-package-name">' + data.custphone + '</td>') +
                                        '</tr>' +
                                        '</table>' +
                                        '<div class="arrow">' +
                                        '<div class="arrow-inner"></div>' +
                                        '</div>' +
                                        '</div>' +
                                        '</div>';
                                $("body").append(tooltip);
                                $(this).mouseover(function (e) {
                                    $(this).css('z-index', 10000);
                                    $('.tooltiptopicevent').fadeIn('500');
                                    $('.tooltiptopicevent').fadeTo('10', 1.9);
                                }).mousemove(function (e) {

                                    $('.tooltiptopicevent').css('top', ($(this).offset().top - 30) + "px");
                                    $('.tooltiptopicevent').css('left', ($(this).offset().left + $(this).width() / 2) + "px");
                                });
                            },
                            eventMouseout: function (data, event, view) {
                                $(this).css('z-index', 8);
                                $('.tooltiptopicevent').remove();
                            },
                            eventClick: function (event, jsEvent, view) {
                                if (event.event_type == "Unavailable") {
                                    return;
                                }

                                //set the values and open the modal
                                showAppointmentDetail(event.appointment_id, event);


                            },
                            eventDrop: function (event, delta, revertFunc) {

                                console.log(event.start.unix());
                                var data = {};
                                if (event.event_type == "Unavailable") {

                                    data = {
                                        unavailable_id: event.id,
                                        noton: moment(event.start).format('DD-MM-YYYY'),
                                        time_from: moment(event.start).format('HH:mm:ss'),
                                        time_to: moment(event.end).format('HH:mm:ss')
                                    };

                                    scheduler.updateUnavailableTime(data).then(function (data) {

                                    }).catch(function (response) {
                                        revertFunc();
                                    }).finally(function () {

                                    });

                                } else {
                                    data = {
                                        appointment_service_id: event.id,
                                        ison: moment(event.start).format('DD-MM-YYYYHH:mm:ss'),
                                        staff_id: event.resourceId
                                    };

                                    scheduler.updateAppointmentService(data).then(function (data) {

                                    }).catch(function (response) {
                                        revertFunc();
                                    }).finally(function () {

                                    });
                                }

                            },
                            select: function (start, end, jsEvent, view, resource) {
                                console.log(
                                        'select',
                                        start.format(),
                                        end.format(),
                                        resource ? resource.id : '(no resource)'
                                        );
                            },
                            dayClick: function (date, jsEvent, view, resource) {
                                //var token = $('#token').val();
                                //var salonId = $('#salon_id').val();
                                var objDate = date.toDate();
                                //selectOption(objDate, resource, token, salonId);
                                //$state.go('app.addStaff');
                                ctrl.addAppointment(objDate, resource);
                            }
                        });
                        var empList = "<div class='list no-bg full-width' id='staffWrapper'><label class='item item-input item-select validated'><div><div class='input-label'>&nbsp;</div>" +
                                "<select class='form-control' id='staffList' onchange='staffSelectionChanged()'><option value='all'>All Staff</option></select>" +
                                "</div></label></div>";
                        $('.fc-center').append(empList);

                        scope.$on("$destroy", function () {
                            // Remove jQuery plugin from element to prevent memory leaks
                            // If your plugin doesn't have a remove function its probably not well suited to persistent javascript environments
                            angular.element(element).fullCalendar('destroy');
                        });
                    }
                };
            }]);


