angular.module('your_app_name.services', [])

        .service('LoginService', function ($q, $http, $rootScope) {
            return {
                loginUser: function (email, passwd) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/salonJsonLoginAPI',
                        //url: 'http://www.londonmassagecare.com/public/api/v1/therapists',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {email: email, password: passwd}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                signup: function (objDetail) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/salon-registration',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objDetail

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                forgotPassword: function (email) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/forgot-password-salon',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {email: email}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }

            };
        })

        .service('UserService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getAddress: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/v1/customerAddress',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                saveAddress: function (address) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/v1/saveCustomerAddress',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                updateProfile: function (objUser) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/update-profile',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objUser

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                changePassword: function (objPass) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/change-password',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objPass

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                saveDeviceID: function (userID, deviceID, device) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/save-deviceId',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {user_id: userID, device_id: deviceID, device_name: device, type: deviceType}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getPaymentStatus: function (salonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/payment-status/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }

            };
        })

        .service('UserLocation', function ($cordovaGeolocation, $rootScope, $q, $timeout) {
            this.getMyLocation = function () {
                var q = $q.defer();
                var options = {
                    timeout: 10000,
                    enableHighAccuracy: false
                };
                var located = function () {
                    $cordovaGeolocation.getCurrentPosition(options).then(function (position) {
                        q.resolve(position);
                    }, function (error) {
                        q.reject(error);
                    });
                };
                ionic.Platform.ready(function () {
                    // will execute when device is ready, or immediately if the device is already ready.
                    located();
                });
                //$timeout(function () { located(); },2000);
                return q.promise;
            };
        })

        .service('AppointmentService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getPending: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salon-pendingappointment/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getUpcoming: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salon-upcomingappointment/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getToday: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salon-todayappointment/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getServices: function (AppointmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/view-service-api/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                approveService: function (AppointmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/approveService/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                rejectService: function (AppointmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/reject-appointment/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                completeService: function (AppointmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/completeService/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }

            };
        })

        .service('OrderService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getPending: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/pendingorder-api/' + CustomerID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getUpcoming: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/upcomingorder-api/' + CustomerID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getCompleted: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/completedorder-api/' + CustomerID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getServices: function (OrderID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/order-productdetail/' + OrderID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                saveReview: function (AppointmentID, salonID, userID, rating, desc) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/save-fashionreview/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {user_id: userID, appointment_id: AppointmentID, salon_id: salonID, rating: rating, desc: desc}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }

            };
        })

        .service('RequestService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getRequests: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/viewpostrequest-api/' + CustomerID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getUpcoming: function (CustomerID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/upcoming-api/' + CustomerID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getBids: function (AppointmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/requestbid-api/' + AppointmentID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {address1: address}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                saveRequest: function (objRequest) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/save-postrequest',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objRequest

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                assignBid: function (bidID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/requestbid-select/' + bidID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: objRequest

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }

            };
        })

        .service('TreatmentService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getTreatmentList: function () {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/index/service',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })

        .service('SalonService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getSalonList: function (serviceID, day, toValue, fromValue, businessType, longitude, latitude, listIndex, noOfRecord) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/getServiceSearch/' + serviceID + '/' + day + '/' + toValue + '/' + fromValue + '/' + businessType + '/' + longitude + '/' + latitude + '/' + listIndex + '/' + noOfRecord,
                        //url: $rootScope.API_URL+'/getServiceSearch/479/5/300/0/1/-2.9915726/53.4083714/0/5',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getSalonServiceList: function (salonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/salonDetail/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getSalonReviewList: function (salonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/rating-api/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getTimeByDay: function (salonID, weekDay) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/getTimeByDay/' + salonID + '/' + weekDay,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getFashionList: function (toValue, fromValue, longitude, latitude, listIndex, noOfRecord) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/getFashionSearch/' + toValue + '/' + fromValue + '/' + longitude + '/' + latitude + '/' + listIndex + '/' + noOfRecord,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getFashionProductList: function (salonID, listIndex, noOfRecord) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/salon-fashion-json/' + salonID + '/' + listIndex + '/' + noOfRecord,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                searchSalon: function (keyWord) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salonsearch-byname/' + keyWord,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getSalonGallery: function (salonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salonimage-gallery/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getSalonOfferList: function () {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/salon-specialoffer',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getFashionOfferList: function () {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/fashion-specialoffer',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {token: $rootScope.userAuthToken}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })

        .service('ViewDetail', function ($q, $http, $localstorage, $rootScope) {
            return {
                getCustomer: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewCust/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getStaff: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewStaff/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getBudgetBooking: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewBudgetBooking/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getSpecialOffer: function (SalonID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewSpecialOffer/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: {customer_id: CustomerID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })

        .service('PanelService', function ($q, $http, $localstorage, $rootScope) {
            return {
                addCustomer: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddCust',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                editCustomer: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiUpdateCust',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addStaff: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddStaff',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                editStaff: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiUpdateStaff',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addBookingBid: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiSaveBid',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewSelectedBooking: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiSelectedBudgetBooking/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewService: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewService/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addService: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddService',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                editService: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiUpdateService',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addNewService: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiReqNewService',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addSpecialOffer: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddSpecialOffer',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                editSpecialOffer: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiUpdateSpecialOffer',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addProfile: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiupdateProfile',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewProfile: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewProfile/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addLocation: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddLocation',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewLocation: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewLocation/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addCustomerDiscount: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddFirstTimeDiscount',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewCustomerDiscount: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewFirstTimeDiscount/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                saveSocialLink: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiSetLinks',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewSocialLink: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewLinks/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addOpeningTime: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiOpeningTime',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewOpeningTime: function (SalonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewOpeningTime/' + SalonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                deleteCustomer: function (ID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiDeleteCust/' + ID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                deleteStaff: function (ID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiDeleteStaff/' + ID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                deleteService: function (ID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiDeleteService/' + ID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                deleteSpecialOffer: function (ID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiDeleteSpecialOffer/' + ID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getStaffServices: function (salonID, staffID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewSalonService/' + salonID + '/' + staffID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getStaffUnavailableTime: function (salonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiViewStaffUnavailableTime/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                makeStaffAvailableTime: function (unavailableID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/api/apiMakeAvailable/' + unavailableID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addAppointment: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/saveCalendarBooking',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addStaffUnavailability: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/saveStaffUnavailability',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                addStaffService: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/apiAddStaffService',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getBraintreeToken: function (salonID) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/client-token/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                makePayment: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/add-order',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getPackagePrice: function () {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/package-price',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getReport: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'GET',
                        url: $rootScope.API_URL + '/api/apiViewClickCount/' + objData.salonId + '/' + objData.dateFrom + '/' + objData.dateTo,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getClickReport: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'GET',
                        url: $rootScope.API_URL + '/api/apiClickCountDetail/' + objData.dateFrom + '/' + objData.dateTo + '/' + objData.salonId,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getAppointmentReport: function (objData) {
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'GET',
                        url: $rootScope.API_URL + '/api/apiAppointmentDetailTime/' + objData.dateFrom + '/' + objData.dateTo + '/' + objData.salonId,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
                                //data: objData

                    }).success(function (data) {
//logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })


        .service('scheduler', function ($http, $rootScope, $q, $timeout, $localstorage, $ionicLoading) {
            return {
                getStaffList: function (salonID) {
                    $ionicLoading.show();
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/getStaffList/' + salonID + '/undefined',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        $ionicLoading.hide();
                        q.resolve(data);
                    }).error(function (data) {
                        $ionicLoading.hide();
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewService: function (salonID) {
                    $ionicLoading.show();
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/viewService/' + salonID + '/undefined',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        $ionicLoading.hide();
                        q.resolve(data);
                    }).error(function (data) {
                        $ionicLoading.hide();
                        q.reject(data);
                    });
                    return q.promise;
                },
                viewUnavailableTime: function (salonID) {
                    $ionicLoading.show();
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'get',
                        url: $rootScope.API_URL + '/viewUnavailableTime/' + salonID,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON'
//data: {customer_id: CustomerID}

                    }).success(function (data) {
//logStatus(data);
                        $ionicLoading.hide();
                        q.resolve(data);
                    }).error(function (data) {
                        $ionicLoading.hide();
                        q.reject(data);
                    });
                    return q.promise;
                },
                updateAppointmentService: function (objData) {
                    $ionicLoading.show();
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/updateAppointmentService',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        $ionicLoading.hide();
                        q.resolve(data);
                    }).error(function (data) {
                        $ionicLoading.hide();
                        q.reject(data);
                    });
                    return q.promise;
                },
                updateUnavailableTime: function (objData) {
                    $ionicLoading.show();
                    var q = $q.defer();
//logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/updateStaffUnavailability',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objData

                    }).success(function (data) {
//logStatus(data);
                        $ionicLoading.hide();
                        q.resolve(data);
                    }).error(function (data) {
                        $ionicLoading.hide();
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })

        .service('TherapistService', function ($q, $http, $localstorage, $rootScope) {
            return {
                getTherapistList: function (treatmentID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/v1/therapistList',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {treatment_id: treatmentID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                getTherapistTime: function (therapistID) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/v1/timeByTherapist',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: {therapist_id: therapistID}

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })

        .service('Booking', function ($q, $http, $localstorage, $rootScope) {
            return {
                bookAppointment: function (objCart) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/save-appointment',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objCart

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                },
                bookOrder: function (objCart) {
                    var q = $q.defer();
                    //logStatus(JSON.stringify($criteria));
                    $http({
                        method: 'post',
                        url: $rootScope.API_URL + '/api/save-fashion',
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            'Authorization': 'Bearer ' + $localstorage.get('userAuthToken')
                        },
                        dataType: 'JSONP',
                        contentType: 'application/JSON',
                        data: objCart

                    }).success(function (data) {
                        //logStatus(data);
                        q.resolve(data);
                    }).error(function (data) {
                        q.reject(data);
                    });
                    return q.promise;
                }
            };
        })



        .service('FeedList', function ($rootScope, FeedLoader, $q) {
            this.get = function (feedSourceUrl) {
                var response = $q.defer();
                //num is the number of results to pull form the source
                FeedLoader.fetch({q: feedSourceUrl, num: 20}, {}, function (data) {
                    response.resolve(data.responseData);
                });
                return response.promise;
            };
        })


// PUSH NOTIFICATIONS
        .service('PushNotificationsService', function ($rootScope, $cordovaPush, NodePushServer, GCM_SENDER_ID) {
            /* Apple recommends you register your application for push notifications on the device every time it’s run since tokens can change. The documentation says: ‘By requesting the device token and passing it to the provider every time your application launches, you help to ensure that the provider has the current token for the device. If a user restores a backup to a device other than the one that the backup was created for (for example, the user migrates data to a new device), he or she must launch the application at least once for it to receive notifications again. If the user restores backup data to a new device or reinstalls the operating system, the device token changes. Moreover, never cache a device token and give that to your provider; always get the token from the system whenever you need it.’ */
            this.register = function () {
                var config = {};
                // ANDROID PUSH NOTIFICATIONS
                if (ionic.Platform.isAndroid())
                {
                    config = {
                        "senderID": GCM_SENDER_ID
                    };
                    $cordovaPush.register(config).then(function (result) {
                        // Success
                        console.log("$cordovaPush.register Success");
                        console.log(result);
                    }, function (err) {
                        // Error
                        console.log("$cordovaPush.register Error");
                        console.log(err);
                    });
                    $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
                        console.log(JSON.stringify([notification]));
                        switch (notification.event)
                        {
                            case 'registered':
                                if (notification.regid.length > 0) {
                                    console.log('registration ID = ' + notification.regid);
                                    NodePushServer.storeDeviceToken("android", notification.regid);
                                }
                                break;
                            case 'message':
                                if (notification.foreground == "1")
                                {
                                    console.log("Notification received when app was opened (foreground = true)");
                                }
                                else
                                {
                                    if (notification.coldstart == "1")
                                    {
                                        console.log("Notification received when app was closed (not even in background, foreground = false, coldstart = true)");
                                    }
                                    else
                                    {
                                        console.log("Notification received when app was in background (started but not focused, foreground = false, coldstart = false)");
                                    }
                                }

                                // this is the actual push notification. its format depends on the data model from the push server
                                console.log('message = ' + notification.message);
                                break;
                            case 'error':
                                console.log('GCM error = ' + notification.msg);
                                break;
                            default:
                                console.log('An unknown GCM event has occurred');
                                break;
                        }
                    });
                    // WARNING: dangerous to unregister (results in loss of tokenID)
                    // $cordovaPush.unregister(options).then(function(result) {
                    //   // Success!
                    // }, function(err) {
                    //   // Error
                    // });
                }

                if (ionic.Platform.isIOS())
                {
                    config = {
                        "badge": true,
                        "sound": true,
                        "alert": true
                    };
                    $cordovaPush.register(config).then(function (result) {
                        // Success -- send deviceToken to server, and store for future use
                        console.log("result: " + result);
                        NodePushServer.storeDeviceToken("ios", result);
                    }, function (err) {
                        console.log("Registration error: " + err);
                    });
                    $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
                        console.log(notification.alert, "Push Notification Received");
                    });
                }
            };
        })


// BOOKMARKS FUNCTIONS
        .service('BookMarkService', function (_, $rootScope) {

            this.bookmarkFeedPost = function (bookmark_post) {

                var user_bookmarks = !_.isUndefined(window.localStorage.ionFullApp_feed_bookmarks) ?
                        JSON.parse(window.localStorage.ionFullApp_feed_bookmarks) : [];
                //check if this post is already saved

                var existing_post = _.find(user_bookmarks, function (post) {
                    return post.link == bookmark_post.link;
                });
                if (!existing_post) {
                    user_bookmarks.push({
                        link: bookmark_post.link,
                        title: bookmark_post.title,
                        date: bookmark_post.publishedDate,
                        excerpt: bookmark_post.contentSnippet
                    });
                }

                window.localStorage.ionFullApp_feed_bookmarks = JSON.stringify(user_bookmarks);
                $rootScope.$broadcast("new-bookmark");
            };
            this.bookmarkWordpressPost = function (bookmark_post) {

                var user_bookmarks = !_.isUndefined(window.localStorage.ionFullApp_wordpress_bookmarks) ?
                        JSON.parse(window.localStorage.ionFullApp_wordpress_bookmarks) : [];
                //check if this post is already saved

                var existing_post = _.find(user_bookmarks, function (post) {
                    return post.id == bookmark_post.id;
                });
                if (!existing_post) {
                    user_bookmarks.push({
                        id: bookmark_post.id,
                        title: bookmark_post.title,
                        date: bookmark_post.date,
                        excerpt: bookmark_post.excerpt
                    });
                }

                window.localStorage.ionFullApp_wordpress_bookmarks = JSON.stringify(user_bookmarks);
                $rootScope.$broadcast("new-bookmark");
            };
            this.getBookmarks = function () {
                return {
                    feeds: JSON.parse(window.localStorage.ionFullApp_feed_bookmarks || '[]'),
                    wordpress: JSON.parse(window.localStorage.ionFullApp_wordpress_bookmarks || '[]')
                };
            };
        })


// WP POSTS RELATED FUNCTIONS
        .service('PostService', function ($rootScope, $http, $q, WORDPRESS_API_URL) {

            this.getRecentPosts = function (page) {
                var deferred = $q.defer();
                $http.jsonp(WORDPRESS_API_URL + 'get_recent_posts/' +
                        '?page=' + page +
                        '&callback=JSON_CALLBACK')
                        .success(function (data) {
                            deferred.resolve(data);
                        })
                        .error(function (data) {
                            deferred.reject(data);
                        });
                return deferred.promise;
            };
            this.getPost = function (postId) {
                var deferred = $q.defer();
                $http.jsonp(WORDPRESS_API_URL + 'get_post/' +
                        '?post_id=' + postId +
                        '&callback=JSON_CALLBACK')
                        .success(function (data) {
                            deferred.resolve(data);
                        })
                        .error(function (data) {
                            deferred.reject(data);
                        });
                return deferred.promise;
            };
            this.shortenPosts = function (posts) {
                //we will shorten the post
                //define the max length (characters) of your post content
                var maxLength = 500;
                return _.map(posts, function (post) {
                    if (post.content.length > maxLength) {
                        //trim the string to the maximum length
                        var trimmedString = post.content.substr(0, maxLength);
                        //re-trim if we are in the middle of a word
                        trimmedString = trimmedString.substr(0, Math.min(trimmedString.length, trimmedString.lastIndexOf("</p>")));
                        post.content = trimmedString;
                    }
                    return post;
                });
            };
            this.sharePost = function (link) {
                window.plugins.socialsharing.share('Check this post here: ', null, null, link);
            };
        })


        ;
